package com.btcpiyush.ads.google_applovin_unity_ads.interestial_ad

import android.app.Activity
import android.util.Log
import com.btcpiyush.ads.google_applovin_unity_ads.GoogleApplovinUnityAdsPlugin
import com.btcpiyush.ads.google_applovin_unity_ads.api.AppSettings
import com.google.android.gms.ads.AdError
import com.google.android.gms.ads.AdRequest
import com.google.android.gms.ads.FullScreenContentCallback
import com.google.android.gms.ads.LoadAdError
import com.google.android.gms.ads.interstitial.InterstitialAd
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import java.util.*

class AdmobInterstitial(private val flutterPluginBinding: FlutterPlugin.FlutterPluginBinding, private val act: Activity, private val settingResponse: AppSettings) :
    MethodChannel.MethodCallHandler {

    companion object {
        val allAds: MutableMap<Int, InterestialModel> = mutableMapOf()
        val TAG: String = "ADMOBINTER ADS"
    }

    private fun getGoogleAdRequest(): AdRequest {
        return AdRequest.Builder().build()
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        val CHANNEL_INTERESTIAL_NAME = "dev.bitcoding.ads/interstitial"
        showLog("${call.method}  =        = = = = = = = = = = = = = = = = = = = =")
        when (call.method) {
            "isLoaded" -> {
                val id = call.argument<Int>("id")
                val model = allAds[id] ?: return result.success(false)

                if (model.isLoaded)
                    result.success(true)
                else
                    result.success(false)
            }

            "call.ads.interestial" -> {
                val id : Int = call.argument<Int?>("id") ?: 0

                if(allAds[id] == null) {
                    allAds[id] = InterestialModel()
                }

                val model = allAds[id]

                if (model?.isInProgress == true) return

                if (model?.interstialAd != null) return

                val admobID = settingResponse.googleAds?.interstitialId ?: ""

                if (admobID.isNullOrEmpty()) {
                    showLog("admobID is Null or Empty ")
                } else {
                    model?.isInProgress = true
                    // progressBar?.show()
                    val adChannel = MethodChannel(
                        flutterPluginBinding.binaryMessenger,
                        "${CHANNEL_INTERESTIAL_NAME}_$id"
                    )
                    showLog("$admobID is not empty ")
                    val callback = object : InterstitialAdLoadCallback() {
                        override fun onAdLoaded(interstitialAd: InterstitialAd) {
                            super.onAdLoaded(interstitialAd)
                            model?.isInProgress = false
                            model?.isLoaded = true
                            model?.interstialAd = interstitialAd
                            //progressBar?.dismiss()
                            act?.let { showInterestialAds(it, interstitialAd, (model?.pos ?: 0)) }
                            model?.interstialAd?.fullScreenContentCallback =
                                object : FullScreenContentCallback() {
                                    override fun onAdClicked() {
                                        showLog("   --------  Interestial onAdClicked ---   ")
                                        // sendSuccess(result, "   --------  Interestial onAdClicked ---   ")
                                        super.onAdClicked()
                                    }

                                    override fun onAdDismissedFullScreenContent() {
                                        super.onAdDismissedFullScreenContent()
                                        model?.interstialAd = null
                                        /*progressBar?.dismiss()
                                        interestialAdInterval = Calendar.getInstance().timeInMillis*/
                                        showLog("   -------- onAdDismissedFullScreenContent Show ")

                                        adChannel?.invokeMethod(GoogleApplovinUnityAdsPlugin.METHOD_SUCCESS, null)
                                    }

                                    override fun onAdShowedFullScreenContent() {
                                        super.onAdShowedFullScreenContent()

                                        /*progressBar?.dismiss()
                                        showLog(" -------- onAdShowedFullScreenContent Show  --- ")*/
                                        // sendSuccess(result, "   -------- onAdShowedFullScreenContent Show  ---   ")
                                    }

                                    override fun onAdFailedToShowFullScreenContent(adError: AdError) {
                                        super.onAdFailedToShowFullScreenContent(adError)
                                        showLog(
                                            " -------- onAdFailedToShowFullScreenContent Show  --- $adError"
                                        )
                                        /* mGoogleInterstitialAd = null
                                         GoogleApplovinUnityAdsPlugin.handler.postDelayed({
                                           if (otherList.size > 0 && otherList.size > extraGooglepos) {
                                             loadExtraGoogleAdsInterestialAds(
                                               act, result, pos, extraGooglepos + 1,
                                               otherList
                                             )
                                           } else {
                                             loadInterestialAds(act, result, pos + 1)
                                           }
                                         }, 10L)*/
                                    }

                                    override fun onAdImpression() {
                                        super.onAdImpression()
                                        showLog(
                                            " -------- onAdImpression Show  --- "
                                        )
                                        /*sendSuccess(
                                            result,
                                            "   -------- onAdImpression Show  ---   "
                                        )*/
                                    }
                                }
                        }

                        override fun onAdFailedToLoad(loadAdError: LoadAdError) {
                            super.onAdFailedToLoad(loadAdError)
                            model?.isInProgress = false
                            showLog("onAdFailedToLoad: ")
                            adChannel?.invokeMethod(GoogleApplovinUnityAdsPlugin.METHOD_ERROR, null)
                            // loadInterestialAds(act, result, (model?.pos ?: 0) + 1)
                        }
                    }

                    act?.let { InterstitialAd.load(it, admobID, getGoogleAdRequest(), callback) }
                }
            }
            "call.ads.interestial.dispose" -> {
                val id = call.argument<Int>("id")
                allAds.remove(id)
            }
            else -> result.notImplemented()
        }
    }

    private fun showInterestialAds(
        act: Activity,
        mGoogleInterstitialAd: InterstitialAd?,
        pos: Int
    ) {
        mGoogleInterstitialAd?.let {
            showLog("Google Ads Show Completed")
            try {
                it.show(act)
            } catch (e: Exception) {
                e.printStackTrace()
                /*methodChannel?.invokeMethod(GoogleApplovinUnityAdsPlugin.METHOD_ERROR, null)*/
            }
        } ?: kotlin.run {
            showLog("Error is  Google Ads Not Loading")
            /*methodChannel?.invokeMethod(GoogleApplovinUnityAdsPlugin.METHOD_ERROR, null)*/
        }
    }

    private fun showLog(error: String) {
        Log.e(TAG, error)
    }

}
