import 'dart:async';
import 'dart:io';

import 'package:flutter/services.dart';
import 'package:google_applovin_unity_ads/interestial/admob_events.dart';
import 'package:google_applovin_unity_ads/interestial/event_handler.dart';

class InterstitialAd extends AdmobEventHandler {
  static const MethodChannel _channel =
      MethodChannel('dev.bitcoding.ads/interstitial');

  late int id;
  late MethodChannel _adChannel;
  final void Function(AdmobAdEvent, Map<String, dynamic>?)? listener;

  InterstitialAd({
    this.listener,
  }) : super(listener) {
    id = hashCode;
    if (listener != null) {
      _adChannel = MethodChannel('dev.bitcoding.ads/interstitial_$id');
      _adChannel.setMethodCallHandler(handleEvent);
    }
  }

  Future<bool?> get isLoaded async {
    final result = await _channel.invokeMethod('isLoaded', _channelMethodsArguments);
    return result;
  }

  void load() async {
    await _channel.invokeMethod('call.ads.interestial',
      _channelMethodsArguments
    );
  }

  void dispose() async {
    await _channel.invokeMethod('dispose', _channelMethodsArguments);
  }

  Map<String, dynamic> get _channelMethodsArguments => <String, dynamic>{
    'id': id,
  };
}
